// ========================== IMAGE INTERFACE ======================== //
// Type: image											   //
// =================================================================== //

#ifndef _IIMAGE_
#define _IIMAGE_

#include <map>
#include <string>
#include <vector>

#include <string>
#include <gtk/gtk.h>

#include "gloobus-preview-interface-main.h"

using namespace std;

class iImage : public interface
{
	protected:
	//string			 m_filename;							//From class interface
	GdkPixbuf 			*m_pixbuf;
	GtkWidget 			*m_image;
	GtkWidget 			*m_image_container;

	public:
	virtual GdkPixbuf*		get_pixbuf  () = 0;					//Developed by the plugins

	
			virtual void			load		();
			virtual int 			get_width	();
			virtual int 			get_height	();
			virtual	void			draw		( GtkContainer * container );
			virtual void			end			();

			void			draw_image		( GtkContainer * container ); 
			void 			draw_file_info 	( GtkContainer * container );

							~iImage();
	private:
			void			scale_image  ( int max_x, int max_y);



};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iImage* create_t_image();									//CREATE PLUGIN
typedef void destroy_t_image(iImage*);							   	//DESTROY PLUGIN
	
extern map<string, create_t_image *, less<string> > factory_image;		   //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_image *, less<string> > factoryDestroy_image; //MAP WITH NAME AND DESTRUCTOR
extern vector<plugin_filetype> pluginVector;				   		 	   //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
