// ========================== Music INTERFACE ======================== //
// Type: movie				 							   //
// =================================================================== //

#ifndef _IMOVIE_
#define _IMOVIE_

#include <map>
#include <string>
#include <vector>

#include <string>



#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include "gloobus-preview-interface-main.h"

using namespace std;

class iMovie : public interface
{
	protected:
	 	GtkWidget		*m_drawable;
	 	GtkWidget		*m_container;
	 	
		GtkWidget 		*m_scale;			//Seek Bar
		int 			m_timeout_id;

	public:

								~iMovie 	( void );
		//Virtual Functions implemented from interface

		virtual void			load		();
		virtual int 			get_width	();
		virtual int 			get_height	();
		virtual	void			draw		( GtkContainer * container );
		virtual void			end			( void );
		
		//================= PLAYER FUNCTIONS =================== //
		virtual void			play 			( void ) = 0;
		virtual void			stop 			( void ) = 0;
		virtual double			get_position	( void ) = 0;
		virtual void			seek			( gdouble value )   = 0;

				void			draw_movie		( GtkContainer * container);
				void			draw_controls	( GtkContainer * container);
				void			draw_position	( void );
				void			create_timeout	( void );

		// Callback
		static void trick	(GtkRange *range, GtkScrollType scroll, gdouble value, gpointer prInstance)						
		{
			iMovie * instance = (iMovie*)prInstance;
			instance->seek( value );					
		}
		static gboolean trick2	(gpointer prInstance)						
		{
			iMovie * instance = (iMovie*)prInstance;
			instance->draw_position( );		
			return true;						//To keep calling the function
		}

};

//==============  CLASS FACTORIES DEFINITIONS================================= //

typedef iMovie* create_t_movie();									   	//CREATE PLUGIN
typedef void destroy_t_movie(iMovie*);							   		//DESTROY PLUGIN
//typedef int getVersion_t();									   		//GET PLUGIN_MANAGER VERSION
//	
extern map<string, create_t_movie *, less<string> > factory_movie;		   	 //MAP WITH NAME AND CONSTRUCTOR
extern map<string, destroy_t_movie *, less<string> > factoryDestroy_movie;   //MAP WITH NAME AND DESTRUCTOR
//extern vector<plugin_filetype> pluginVector;				          		 //VECTOR TO STORE WICH FILETYPE READ EACH PLUGIN

#endif
